
/*
//	**** ATXMEG32A4/(ATXMEGA128A1/A3)
//	hier: Atxmega32a4, Internal 32/2 = 16 Mhz MHz RC oscillator 
//  Display EA DOGS102 
//	Library fr EA-DOGM Grafikdisplays inkl. Font-Generator 
//	Version 0.95 Autor: Jan M.
//	http://www.mikrocontroller.net/topic/144500#new
// 
//	Atxmega32a4					DOGS102		DOGM128/132 DOGXL160
// -----------------------------------------------------------------------------
// LCD_A0/CD   PC2 (Pin 12) -> 	PIN 26		PIN 38	  	Pin 27
// LCD_RST     PC3 (Pin 13) ->	PIN 27 		PIN 39   	Pin 29
// LCD_CS      PC4 (Pin 14) -> 	PIN 28 		PIN 40   	Pin 28
// MOSI        PC5 (Pin 15) -> 	PIN 24		PIN 36   	Pin 31
// MISO        PC6 (Pin 16) ->  ------		------		------
// SCK         PC7 (Pin 17) -> 	PIN 25		PIN 37   	Pin 32


//	Atxmega128a1/Atxmega128a3   DOGS102		DOGM128/132	DOGXL160
//-------------------------------------------------------------------------------
// LCD_A0      PC2 (Pin 18)	->	PIN 26		PIN 38		Pin 27
// LCD_RST     PC3 (Pin 19)	->	PIN 27 		PIN 39		Pin 29
// LCD_CS      PC4 (Pin 20)	->	PIN 28 		PIN 40 		Pin 28
// MOSI        PC5 (Pin 21) -> 	PIN 24		PIN 36		Pin 31
// MISO        PC6 (Pin 22) ->  ------		------		------
// SCK         PC7 (Pin 23) -> 	PIN 25		PIN 37		Pin 32

*/





#include "tools.h"


// bindet printf() LCD ein 
static FILE mystdout  = FDEV_SETUP_STREAM(display_putchar, NULL, _FDEV_SETUP_WRITE); 

// suche Sensor
#define MAXSENSORS 2
uint8_t gSensorIDs[MAXSENSORS][OW_ROMCODE_SIZE];


typedef struct { 			// Struct fr 2 Sensor DS18B20
uint8_t cel_frac_bits[2];	
uint8_t	cel[2];					
uint8_t subzero[2];
} BUFFER_1;

static  BUFFER_1 ds18b20; 


#ifndef OW_ONE_BUS // Sensor DS18B20
ow_set_bus(&PORTD_IN,&PORTD_OUT,&PORTD_DIR,1);//PORTD, PD1	
#endif



int main(void)
{
	system_clocks_init();	// Clock	ein

	PMIC.CTRL = PMIC_LOLVLEN_bm | PMIC_MEDLVLEN_bm | PMIC_HILVLEN_bm;
  	
	lcd_init();			// DOGM/DOGS/DOGXL Init
	delay_ms(100);  	// 100ms warten Display Init

	stdout = &mystdout; // bindet printf() ein 
	lcd_set_font(FONT_PROP_8,NORMAL); // LCD-Font setzen
  		
	lcd_moveto_xy(0,0);	// Ausgabe Display
	printf("DS18B20 Test ok!");

	
 	PORTB_DIRTGL   = PIN0_bm;  //Messung aktiv

	sei();
	
	
	
	while(1)
	{	

	ds18x20_starten();			// Temperatur lesen
	PORTB_OUTTGL   = PIN0_bm;	// LED toggle
	delay_ms(250);
	PORTB_OUTTGL   = PIN0_bm;	// LED toggle
	delay_ms(250);
	

	}

	return (0);
}




uint8_t search_sensors(void) 
{
	uint8_t i;
	uint8_t id[OW_ROMCODE_SIZE];
	uint8_t diff, nSensors;
	
	
	nSensors = 0;
	
	for( diff = OW_SEARCH_FIRST; 
		diff != OW_LAST_DEVICE && nSensors < MAXSENSORS ; )
	{
		DS18X20_find_sensor( &diff, &id[0] );
		
		if( diff == OW_PRESENCE_ERR ) {
			lcd_moveto_xy(3,0);printf("No Sensor" );
			break;
		}
		
		if( diff == OW_DATA_ERR ) {
			lcd_moveto_xy(3,0);printf("Bus Error" );
			break;
		}
		
		for (i=0;i<OW_ROMCODE_SIZE;i++)
			gSensorIDs[nSensors][i]=id[i];
		
		nSensors++;
	}
	
	return nSensors;
}

//---------------------------------------------------------------------------//

// Sensor auslesen




void ds18x20_auslesen(void)
{

	
	uint8_t nSensors, i;
	uint8_t subzero, cel, cel_frac_bits;

	
	nSensors = search_sensors();
	
		lcd_moveto_xy(3,0); 
		
		if (DS18X20_start_meas( DS18X20_POWER_PARASITE, NULL ) == DS18X20_OK) 
			{
			
			delay_ms(DS18B20_10_BIT );
			for ( i=0; i<nSensors; i++ )
				 {
				
				if ( DS18X20_read_meas( &gSensorIDs[i][0], &subzero,&cel, &cel_frac_bits) == DS18X20_OK ) 
					
					{
					ds18b20.cel_frac_bits[i] = cel_frac_bits ;
					ds18b20.cel[i] = cel;
					ds18b20.subzero[i] = subzero;
					
					}
				else
					{ 
					lcd_moveto_xy(3,0); 
					printf("CRC Error    ");
					
					}
						
				} // Ende for
		
		}
		else {
			lcd_moveto_xy(3,0); 
			printf("Start meas. failed   ");
			
			}	

}


void ds18x20_starten(void)	
{		
			ds18x20_auslesen();
			
			lcd_moveto_xy(1,0);  // Sensor 1
			printf("Temp1 %c %d C",(ds18b20.subzero[1])?'-':'+',ds18b20.cel[1]);// Minus oder Plus Temperatur

			lcd_moveto_xy(2,0);  // Sensor 2
			printf("Temp2 %c %d C",(ds18b20.subzero[0])?'-':'+',ds18b20.cel[0]);// Minus oder Plus Temperatur
			

} 







int display_putchar(char c, FILE *stream) // // bindet printf() ein
{
 	lcd_putc(c); //LIB DOGMS132
    return 0;
}





void system_clocks_init(void)// System Clocks initialization intern 16 Mhz
{
	unsigned char n,s;
	s=SREG;
	cli();
	OSC.CTRL|=OSC_RC32MEN_bm;
	n=(CLK.PSCTRL & (~(CLK_PSADIV_gm | CLK_PSBCDIV1_bm | CLK_PSBCDIV0_bm))) |
	CLK_PSADIV_2_gc | CLK_PSBCDIV_1_1_gc; // Hier kann der Takt umgestellt werden!! 
	CCP=CCP_IOREG_gc;
	CLK.PSCTRL=n;
	DFLLRC32M.CTRL&= ~DFLL_ENABLE_bm;
	while ((OSC.STATUS & OSC_RC32MRDY_bm)==0);
	n=(CLK.CTRL & (~CLK_SCLKSEL_gm)) | CLK_SCLKSEL_RC32M_gc;
	CCP=CCP_IOREG_gc;
	CLK.CTRL=n;
	OSC.CTRL&= ~(OSC_RC2MEN_bm | OSC_RC32KEN_bm | OSC_XOSCEN_bm | OSC_PLLEN_bm);
	PORTCFG.CLKEVOUT |= PORTCFG_CLKOUT_OFF_gc;
	SREG=s;
	}




//-------------------------------------Ende-------------------------------------

